import { Injectable } from '@angular/core';
import { Http, Response } from '@angular/http';
import { Observable } from 'rxjs/Rx';
import { IHome } from './home';

@Injectable()
export class HomeService {

    private _testUrl = 'https://jsonplaceholder.typicode.com/posts';
    private _userUrl = 'https://jsonplaceholder.typicode.com/users';

    constructor(private _http: Http) { }


    getHome(): Observable<IHome[]> {
        return this._http.get(this._testUrl, { withCredentials: true })
            .map((response: Response) => <IHome[]>response.json())
            .do(data => console.log('All: ' + JSON.stringify(data)))
            .catch(this.handleError);
    }

    getUsers(): Observable<any> {
        return this._http.get(this._userUrl, { withCredentials: true })
            .map((response: Response) => <any>response.json())
            .do(data => console.log('Users: ' + JSON.stringify(data)))
            .catch(this.handleError);
    }

    validateUser(user: string): Observable<any> {
        return this._http.get(this._userUrl + "/" + user, { withCredentials: true })
            .map((response: Response) => { if (response) { return true; } else { return false } })
            .do(data => console.log('users: ' + JSON.stringify(data)))
    }

    private handleError(error: Response) {
        console.error(error);
        return Observable.throw(error.json().error || 'Server error');
    }

}
